#include "stdafx.h"
#include <atlbase.h>
#include "../../../sdk/AtlServer/include/atlrx.h"
#include <wininet.h>
#include "../../../common/corevalueregistryconst.h"
#include "ObserverTool.h"


//
// BTS-117 101022 Ȳ
//  ⺻ ˻ DisplayName
// BO  帧 ϱⰡ ʹ  ̷  .
//   ǽôº ˼ؿ Ф;;
//
CString DefaultSearchObserver::sm_strName;

DefaultSearchObserver::DefaultSearchObserver()
{
	SetDisplayName( IE_SEARCH_DISPLAYNAME );
	SetSearchUrl( IE_SEARCH_URL );
	SetSearchGUID( CLSID_NAVER );
}

void DefaultSearchObserver::SetDisplayName( LPCTSTR name )
{
	Checked::tcscpy_s( m_name, OBSERVER_PARAMETER_SIZE, name );
	m_name[OBSERVER_PARAMETER_SIZE-1] = 0;
}

void DefaultSearchObserver::SetSearchUrl( LPCTSTR url )
{
	Checked::tcscpy_s( m_url, OBSERVER_PARAMETER_SIZE, url );
	m_url[OBSERVER_PARAMETER_SIZE-1] = 0;
}

void DefaultSearchObserver::SetSearchGUID( LPCTSTR guid )
{
	Checked::tcscpy_s( m_guid, OBSERVER_PARAMETER_SIZE, guid );
	m_guid[OBSERVER_PARAMETER_SIZE-1] = 0;
}

bool DefaultSearchObserver::IsValidSearchUrl( const TCHAR *url )
{
	bool bRet = false;
	if( url != NULL )
	{
		if( _tcsstr( url, SEARCH_MAIN_URL ) != 0 )
			bRet = true;
	}

	return bRet;
}

BOOL DefaultSearchObserver::IsCoreValue()
{
	CRegKey RegSearchBar;
	BOOL bRet = FALSE;

	if ( RegSearchBar.Open(HKEY_CURRENT_USER, SUBKEY_SEARCH_SCOPES, KEY_READ ) == ERROR_SUCCESS )
	{
		TCHAR szFullReg[OBSERVER_PARAMETER_SIZE]; 
		ZeroMemory(szFullReg, sizeof(szFullReg));
		lstrcpy( szFullReg, SUBKEY_SEARCH_SCOPES);
		lstrcat( szFullReg, _T("\\"));

		ULONG ul = OBSERVER_PARAMETER_SIZE;
		TCHAR szBuf[OBSERVER_PARAMETER_SIZE]; ZeroMemory(szBuf, sizeof(szBuf));
		RegSearchBar.QueryStringValue(REGVAL_DEFAULT_SCOPE, szBuf, &ul);

		lstrcat( szFullReg, szBuf);
		CRegKey RegDefaultScope;
		if ( RegDefaultScope.Open(HKEY_CURRENT_USER, szFullReg, KEY_READ) == ERROR_SUCCESS )
		{
			TCHAR szName[OBSERVER_PARAMETER_SIZE];
			TCHAR szUrl[OBSERVER_PARAMETER_SIZE];

			ul = OBSERVER_PARAMETER_SIZE;
			RegDefaultScope.QueryStringValue( REGVAL_DISPLAYNAME, szName, &ul);
			sm_strName = szName;

			ul = OBSERVER_PARAMETER_SIZE;
			RegDefaultScope.QueryStringValue( REGVAL_URL, szUrl, &ul);

			if ( lstrcmpi(szName, m_name) == 0 && IsValidSearchUrl(szUrl) == true )
				bRet = TRUE;
		}
	}

	return bRet;

}

BOOL DefaultSearchObserver::IsChangedCoreValue()
{
	BOOL isCoreValueChanged = TRUE;
	LONG lResult = ERROR_SUCCESS ;
	CRegKey RegKey ;
	if (RegKey.Open(HKEY_CURRENT_USER, SUBKEY_SEARCH_SCOPES, KEY_READ) == ERROR_SUCCESS)
	{
		TCHAR szFullReg[OBSERVER_PARAMETER_SIZE]; ZeroMemory(szFullReg, sizeof(szFullReg));
		lstrcpy( szFullReg, SUBKEY_SEARCH_SCOPES);
		lstrcat( szFullReg, _T("\\"));

		TCHAR szBuf[OBSERVER_PARAMETER_SIZE];
		TCHAR szName[OBSERVER_PARAMETER_SIZE];
		TCHAR szUrl[OBSERVER_PARAMETER_SIZE];
		ULONG ul = OBSERVER_PARAMETER_SIZE;

		if (RegKey.QueryStringValue(REGVAL_DEFAULT_SCOPE, szBuf, &ul) == ERROR_SUCCESS)
		{
			lstrcat( szFullReg, szBuf);
			CRegKey RegDefaultScope;
			if ( RegDefaultScope.Open(HKEY_CURRENT_USER, szFullReg, KEY_READ) == ERROR_SUCCESS )
			{
				ul = OBSERVER_PARAMETER_SIZE;
				RegDefaultScope.QueryStringValue( REGVAL_DISPLAYNAME, szName, &ul);
				sm_strName = szName;

				ul = OBSERVER_PARAMETER_SIZE;
				RegDefaultScope.QueryStringValue( REGVAL_URL, szUrl, &ul);

				if ( lstrcmpi(szBuf, szName) == 0 && IsValidSearchUrl(szUrl) == true )
					isCoreValueChanged = FALSE;
			}
		}
	}
	return isCoreValueChanged ;
}

BOOL DefaultSearchObserver::SetCoreValueImpl( LPCTSTR name, LPCTSTR url, LPCTSTR guid )
{
	CRegKey RegSearchBar;
	if ( RegSearchBar.Open(HKEY_CURRENT_USER, SUBKEY_SEARCH_SCOPES ) != ERROR_SUCCESS )
		return FALSE;

	DWORD dwIndex = 0, dwSize = 256;
	TCHAR szEnumRegKey[OBSERVER_PARAMETER_SIZE] ;
	TCHAR szFullReg[OBSERVER_PARAMETER_SIZE];
	TCHAR szBuf[OBSERVER_PARAMETER_SIZE] ;
	ULONG ul = OBSERVER_PARAMETER_SIZE;

	while (::RegEnumKey(RegSearchBar.m_hKey, dwIndex, szEnumRegKey,dwSize) !=  ERROR_NO_MORE_ITEMS)
	{
		ZeroMemory(szFullReg, sizeof(szFullReg));
		lstrcpy( szFullReg, SUBKEY_SEARCH_SCOPES);
		lstrcat( szFullReg, _T("\\"));
		lstrcat( szFullReg, szEnumRegKey);

		CRegKey RegDefaultScope;
		if ( RegDefaultScope.Open(HKEY_CURRENT_USER, szFullReg) == ERROR_SUCCESS )
		{
			ul = OBSERVER_PARAMETER_SIZE;
			ZeroMemory(szBuf, sizeof(szBuf));
			RegDefaultScope.QueryStringValue( REGVAL_DISPLAYNAME, szBuf, &ul);
			if ( lstrcmpi(szBuf, name) == 0 )
			{
				ul = OBSERVER_PARAMETER_SIZE;
				RegDefaultScope.QueryStringValue( REGVAL_URL, szBuf, &ul);
				if( lstrcmpi(szBuf, url) != 0 )
				{
					RegDefaultScope.SetStringValue( REGVAL_URL, url );
				}

				RegDefaultScope.SetDWORDValue(REGVAL_CODEPAGE, REGVAL_DEFAULT_CODEPAGE_VALUE);

				RegSearchBar.SetStringValue( REGVAL_DEFAULT_SCOPE, szEnumRegKey);
				return TRUE;
			}
		}

		ZeroMemory(szBuf, sizeof(szBuf));
		dwSize = COUNTOF(szEnumRegKey) ;
		dwIndex++ ;
	}

	ZeroMemory(szFullReg, sizeof(szFullReg));
	lstrcpy( szFullReg, SUBKEY_SEARCH_SCOPES);
	lstrcat( szFullReg, _T("\\"));
	lstrcat( szFullReg, guid);

	MakeNewSearchBar(szFullReg, guid, name, url);
	RegSearchBar.SetStringValue(REGVAL_DEFAULT_SCOPE, guid);
	return TRUE;
}

BOOL DefaultSearchObserver::MakeNewSearchBar(LPCTSTR regPath, LPCTSTR guid, LPCTSTR name, LPCTSTR url)
{
	CRegKey RegDefaultScope;
	if ( RegDefaultScope.Create(HKEY_CURRENT_USER, regPath ) != ERROR_SUCCESS )
		return FALSE;

	RegDefaultScope.SetStringValue( REGVAL_DISPLAYNAME, name );
	RegDefaultScope.SetStringValue( REGVAL_URL, url );
	RegDefaultScope.SetDWORDValue(REGVAL_CODEPAGE, REGVAL_DEFAULT_CODEPAGE_VALUE);
	return TRUE;
}

BOOL DefaultSearchObserver::SetCoreValue()
{
	return SetCoreValueImpl( m_name, m_url, m_guid );
}






//
// BTS-117 101022 Ȳ
//   URL
// BO  帧 ϱⰡ ʹ  ̷  .
//   ǽôº ˼ؿ Ф;;
//
CString StartPageObserver::sm_strStartPageUrl;

BOOL StartPageObserver::SetCoreValueImpl( LPCTSTR page )
{
	CRegKey RegKey ;
	if (RegKey.Open(HKEY_CURRENT_USER, REGKEY_IE_MAIN) != ERROR_SUCCESS)
		return FALSE;

	LONG result = RegKey.SetStringValue(REGVAL_START_PAGE, page);//QueryStringValue(REGVAL_START_PAGE, pszPage, &dwCount);
	RegKey.Close() ;
	return TRUE;
}

StartPageObserver::StartPageObserver()
{
	SetStartPage(REGVAL_NAVER_URL);
}

void StartPageObserver::SetStartPage( LPCTSTR page )
{
	Checked::tcscpy_s( m_url, OBSERVER_PARAMETER_SIZE, page );
	m_url[OBSERVER_PARAMETER_SIZE-1] = 0;
}


void StartPageObserver::IEGetStartPage(TCHAR *pszPage, int BufferLen)
{
	CRegKey RegKey ;
	*pszPage = _T('\0') ;
	if (RegKey.Open(HKEY_CURRENT_USER, REGKEY_IE_MAIN, KEY_QUERY_VALUE) != ERROR_SUCCESS) return;
	DWORD dwCount = BufferLen;
	RegKey.QueryStringValue(REGVAL_START_PAGE, pszPage, &dwCount);
	RegKey.Close();

	sm_strStartPageUrl = pszPage;
}

BOOL StartPageObserver::IESecondaryStartPages(TCHAR *pszPage, DWORD& BufferLen)
{
	CRegKey RegKey ;
	*pszPage = _T('\0') ;
	if (RegKey.Open(HKEY_CURRENT_USER, REGKEY_IE_MAIN, KEY_QUERY_VALUE) != ERROR_SUCCESS) return FALSE;
	//DWORD dwCount = BufferLen;
	LONG result = RegKey.QueryMultiStringValue(REGVAL_SECONDARY_START_PAGE, pszPage, &BufferLen);
// 	if (ERROR_SUCCESS == result)
// 	{
// 		for (DWORD i = 0; i < BufferLen; i++)
// 		{
// 			if (pszPage[i] == '\0')
// 				pszPage[i] = ';';
// 		}
// 	}
	RegKey.Close();
	return (ERROR_SUCCESS == result);
}


BOOL StartPageObserver::IsCoreValue()
{
	TCHAR szStartPage[INTERNET_MAX_URL_LENGTH] = {0, };
	IEGetStartPage(szStartPage, INTERNET_MAX_URL_LENGTH);

	if (IsNaverUrl(szStartPage))
		return TRUE;
	else
	{
		TCHAR szSecondaryStartPages[INTERNET_MAX_URL_LENGTH] = {0, };
		DWORD SecStartPagesLen = INTERNET_MAX_URL_LENGTH;
		if (IESecondaryStartPages(szSecondaryStartPages, SecStartPagesLen))
		{
			if(IsNaverUrl(szSecondaryStartPages))
				return TRUE;
			for (DWORD i = 0; i < SecStartPagesLen; i++)
			{
				if (szSecondaryStartPages[i] == '\0' && szSecondaryStartPages[i+1] != '\0')
				{
					if(IsNaverUrl(&szSecondaryStartPages[i+1]))
						return TRUE;
				}
			}
		}
	}
	return FALSE;
}


BOOL StartPageObserver::IsChangedCoreValue()
{
	TCHAR szStartPage[INTERNET_MAX_URL_LENGTH];
	IEGetStartPage(szStartPage, INTERNET_MAX_URL_LENGTH);

	if (IsNaverUrl(szStartPage))
		return FALSE;
	else
	{
		TCHAR szSecondaryStartPages[INTERNET_MAX_URL_LENGTH] = {0, };
		DWORD SecStartPagesLen = INTERNET_MAX_URL_LENGTH;
		if (IESecondaryStartPages(szSecondaryStartPages, SecStartPagesLen))
		{
			if(IsNaverUrl(szSecondaryStartPages))
				return FALSE;
			for (DWORD i = 0; i < SecStartPagesLen; i++)
			{
				if (szSecondaryStartPages[i] == '\0' && szSecondaryStartPages[i+1] != '\0')
				{
					if(IsNaverUrl(&szSecondaryStartPages[i+1]))
						return FALSE;
				}
			}
		}
	}
	return TRUE;
}


BOOL StartPageObserver::IsNaverUrl(LPCTSTR url)
{
	if (IsNaverUrlInternal(url, _T("^(http:\\/\\/)*([A-Z|a-z|1-9]+\\.)*naver\\.(com)+(\\/)*$")) == FALSE)
	{
		return IsNaverUrlInternal(url, _T("^(http:\\/\\/)*([A-Z|a-z|1-9]+\\.)*naver\\.(co\\.kr)+(\\/)*$"));
	}
	else
	{
		return TRUE;
	}

	return FALSE;
}


BOOL StartPageObserver::SetCoreValue()
{
	return SetCoreValueImpl(m_url);
}

BOOL StartPageObserver::IsNaverUrlInternal(LPCTSTR url, const TCHAR* regExp)
{
	/*
	?작 ?이지??식?는 케?스 : 
	http://naver.com
	http://naver.com/
	http://www.naver.com
	http://www.naver.com/
	http://naver.co.kr
	http://naver.co.kr/
	http://stock.naver.com
	naver.com
	naver.com/
	naver.co.kr
	naver.co.kr/
	http://www.naver.com/////////

	?작 ?이지??식?? ?는 케?스 : 
	about:blank
	ttp://naver
	http://
	http://naver.
	http://www.daum.net
	www.daum.net
	daum.net
	www
	*/

	// ?규?을 ?용?서 ?의 케?스?서 ?작 ?이지??식?는 케?스?match ??인?도?처리??
	// match ?naver ??작?이지가 ?정?었?고 결정
#ifdef UNICODE
	CAtlRegExp<> regex;
	REParseError status = regex.Parse(regExp, FALSE);
#else
	CAtlRegExp<CAtlRECharTraitsMB> regex;
	REParseError status = regex.Parse(reinterpret_cast<const CAtlRegExp<CAtlRECharTraitsMB>::RECHAR*>(regExp), FALSE);
#endif
	if (REPARSE_ERROR_OK != status) 
	{
		//ASSERT(!_T("Regular Expression is not INVALID"));
		return FALSE;
	} 
	else
	{
#ifdef UNICODE
		CAtlREMatchContext<> mc;
		if (!regex.Match(url, &mc))
#else
		CAtlREMatchContext<CAtlRECharTraitsMB> mc;
		if (!regex.Match(reinterpret_cast<const CAtlRegExp<CAtlRECharTraitsMB>::RECHAR*>(url), &mc))
#endif
		{
			// No match 
			return FALSE;
		} 
		else
		{
			// match
			return TRUE;
		}
	}
}